//XmlExp.h

#ifndef _XMLEXP_H
#define _XMLEXP_H

#include <vector>
#include <map>
#include "./xmlnode/StringUtil.h"
#include "./xmlnode/XmlNode.h"

class INode;

//#define USE_NOSKIN   1

class XmlExp : public XmlNode
{
	struct BlendData
	{
		int		index;
		float	weight;
	};
	typedef std::vector<BlendData>	BlendVector;
	typedef std::map<INode*, int>   INodeIndexMap;

public:
	XmlExp();
	virtual ~XmlExp();

	virtual	const char*	GetClassName();
	
	void	SetINode( INode* pINode );
	void	BuildBoneWeight();

	void    WritePhysiqueWeight( Modifier* pMod );
	void    WriteSkinWeight( Modifier* pMod );
	void	WriteRigging( int nVertexNum, BlendVector* pBlend, const char* riggingType );
	int		FindID( INode* pINode );
	int		GetIndex() { return m_nIndex;  }


private:
	INode*   m_pINode;

public:
	static	int m_nRef;
	static	INodeIndexMap m_indexMap;
	int			m_nIndex;
};

#endif