//XmlNo0de.inl

//ReadXml() ø Լ

//-----------------------------------------------------------------------------
template<class T> 
void _ReadXml( T* dataNode, TiXmlNode* xmlNode, T*& outNode )
{
	if(xmlNode)
	{
		switch(xmlNode->Type())
	   	{
		case TiXmlNode::COMMENT:
		    //std::cout << "COMMENT: " << xmlNode->Value() << std::endl;
		    break;
	   	case TiXmlNode::DECLARATION:
		    //std::cout << "DECLARATION: " << std::endl;
	   	    break;

	   	case TiXmlNode::ELEMENT:
	   		{
				//std::cout << "ELEMENT: [" << xmlNode->ToElement()->Value() << "]" << std::endl;
				if( outNode == NULL )
				{
					dataNode = outNode = new T;
				}
				else
				{
					T* child = new T;
					dataNode->AttachChild( child );
					dataNode = child;
				}

				dataNode->SetName( xmlNode->ToElement()->Value() );
	   			TiXmlAttribute *pAttr = xmlNode->ToElement()->FirstAttribute();
	   			while(pAttr)
	   			{
					dataNode->AddAttribute( pAttr->Name(), pAttr->Value() );
					//std::cout << pAttr->Name() << "=\"" << pAttr->Value() << "\"" << std::endl;
	   	   			pAttr = pAttr->Next();
	   			}
			}
	   		break;

	   	case TiXmlNode::TEXT:
		    TiXmlText* pText = xmlNode->ToText();
		    if(pText)
		    {
			    dataNode->SetData( pText->Value() );
			    //std::cout << "TEXT:  " << pText->Value() << std::endl;
		    }
		    break;
	   	}

	   	for(TiXmlNode *pXmlNext = xmlNode->FirstChild(); pXmlNext; pXmlNext = pXmlNext->NextSibling()) 
		    _ReadXml<T>( dataNode, pXmlNext, outNode );
	}
}
//-----------------------------------------------------------------------------
template<class T> 
T* ReadXml( const char* szName )
{
	TiXmlDocument doc;
	if ( doc.LoadFile( szName ) == false )
	{
		return NULL;
	} 

	T* parent = NULL;
	_ReadXml<T>( NULL, &doc, parent );
	return parent;
}
//-----------------------------------------------------------------------------
template<class T> 
void _WriteXml( T* pNode, TiXmlNode* pXml )
{
	TiXmlElement* xmlNode = (TiXmlElement*)pXml;
	if( pNode->GetName() && pNode->GetName()->empty() == false )
	{
		xmlNode = new TiXmlElement( pNode->GetName()->c_str() );  
		pXml->LinkEndChild( xmlNode ); 

		if(pNode->GetData() && pNode->GetData()->empty() == false )
		{
			xmlNode->LinkEndChild( new TiXmlText( pNode->GetData()->c_str() )); 
		}

		XmlNode::AttributeList* pAttr = pNode->GetAtrributeList();
		XmlNode::AttributeList::iterator iter = pAttr->begin();
		XmlNode::AttributeList::iterator endIter = pAttr->end();
		for( ; iter != endIter; ++iter )
		{
			XmlNode::Attribute* pAttr = *iter;
			xmlNode->SetAttribute( pAttr->name.c_str(), pAttr->value.c_str() );
		}
	}

	XmlNode::ChildList* pChildList = pNode->GetChildList();
	XmlNode::ChildList::iterator iter = pChildList->begin();
	XmlNode::ChildList::iterator endIter = pChildList->end();
	for( ; iter != endIter; ++iter )
	{
		T* k = (T*)*iter;
		_WriteXml<T>( k, (TiXmlNode*)xmlNode );
	}
}
//-----------------------------------------------------------------------------
template<class T> 
void WriteXml( const char* szName, T* root )
{
	TiXmlDocument doc;  
	TiXmlDeclaration* decl = new TiXmlDeclaration( "1.0", "euc-kr", "" );  
	doc.LinkEndChild( decl ); 

	_WriteXml<T>( root, &doc );
	doc.SaveFile( szName );
}
//-----------------------------------------------------------------------------
template<class T>
T* CreateXmlNode( char* szName )
{
	T* pXmlNode = new T;
	pXmlNode->SetName( szName );
	return pXmlNode;
}